﻿//
// WindowsFormsCSharp
//
// Copyright (c) 2016 http://www.curict.com
// This software is released under the MIT License, see LICENSE.txt.
//

using System;
using System.Data;
using System.Windows.Forms;

namespace WindowsFormsCSharp
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // ダミーデータをデータグリッドビューに表示
            DataTable dataTable = new DataTable();
            dataTable.Columns.Add("項目", typeof(string));
            dataTable.Columns.Add("判定", typeof(string));
            dataTable.Rows.Add("データ1", "ok");
            dataTable.Rows.Add("データ2", null);
            dataTable.Rows.Add("データ3", "ok");
            this.dataGridView1.DataSource = dataTable;
        }

        /// <summary>
        /// セルの内容が、表示用に書式指定されなければならないときに発生します
        /// </summary>
        private void dataGridView1_CellFormatting(object sender, DataGridViewCellFormattingEventArgs e)
        {
            DataGridView dataGridView = (DataGridView)sender;

            // イベントのColumnIndexとDataGridViewのColumns[].Nameで列を判断
            if (dataGridView.Columns[e.ColumnIndex].Name == "判定")
            {
                // Cellの値で分岐させ、色を変える
                if (e.Value == null || e.Value == DBNull.Value)
                {
                    // 値が未設定の場合、Cellの背景色を赤・フォント色を白にする
                    e.CellStyle.BackColor = System.Drawing.Color.Red;
                    e.CellStyle.ForeColor = System.Drawing.Color.White;
                }
                else
                {
                    // 値が設定されている場合、Cellの背景色を白・フォント色を黒にする
                    e.CellStyle.BackColor = System.Drawing.Color.White;
                    e.CellStyle.ForeColor = System.Drawing.Color.Black;
                }
            }
        }
    }
}
